# -*- coding: utf-8 -*-
require 'net/http'
require 'json'
class UriShortener
  attr :long_uri
  attr :short_uri
  attr_accessor :type

  def initialize long_uri, type="t.cn"
    @long_uri = URI.encode(long_uri.gsub /^http:\/\/|https:\/\//,"")
    @type = type # t.cn || rdcnzz || url.cn || 126.am
    @short_uri = ""
  end
  
  def shorten
    @short_uri = case @type
                 when "t.cn" then t_cn @long_uri
                 when "url.cn" then url_cn @long_uri
                 when "rdcnzz" then rdcnzz @long_uri
                 when "126.am" then am @long_uri
                 else puts "Not correct type"
                 end
  end

  def verify
    begin
      res = Net::HTTP.get_response URI(@short_uri)
      URI("http://"+@long_uri) == URI(URI.encode res["location"])
    rescue
      false
    end
  end

  private
  def t_cn long_uri
    response = Net::HTTP.post_form(URI("http://tinyurl.duapp.com/create.php"), {:url=>(URI.encode_www_form_component URI.decode(long_uri)), :type=>"t.cn"})
    result = JSON.parse response.body
    result['data']
  end

  def url_cn long_uri
    response = Net::HTTP.get(URI("http://121.199.13.65/web/json.php?type=url.cn&xzurl=#{long_uri}"))
    (/http\:\/\/\w+\.\w+\/\w+/.match response).to_s
  end

  def rdcnzz long_uri
    response = Net::HTTP.get(URI("http://rdcnzz.com/v1/data/link_conv/rd_dispatcher.php?orig_link=#{long_uri}"))
  end

  def am long_uri
    response = Net::HTTP.post_form(URI("http://126.am/api!shorten.action"), {:key=>"d1f04c518037412988e26e449469106f", :longUrl=>(URI.decode "http://"+long_uri)})
    result = JSON.parse response.body
    "http://"+result["url"]
  end
  
end
# 126.am api key: d1f04c518037412988e26e449469106f
